Subject: Re: [RFC/PATCH] git-instaweb: Add support for running gitweb via 'plackup'

From: Jakub Narebski <[email-masked]>
Date: Sun, 23 May 2010 22:21:34 +0200

On Sun, 23 May 2010, Eric Wong wrote:
> Jakub Narebski <[email-masked]> wrote:
> >
> > Do you have any idea on how to synchronize those two processes, the web
> > server and the web client (web browser), so that web browser is run only
> > after web server prints that it is ready to accept connection?
> 
> Your polling http_is_ready() function is fine, and really the only
> portable solution across all servers (and OSes).

Well, even if we use the solution below it would be good fallback for
those web servers, for which the solution below cannot be used.

> 
> But if your webserver lets you run arbitrary code hooks after it
> binds the listen socket, what I do when writing integration tests
> is have it open a FIFO for writing.

I was thinking about 'flock' function in Perl (and similar in other
languages), and '/usr/bin/flock' utility from util-linux.  But using
FIFO as a semaphore might be a better idea: it is slighly more portable,
I guess.

Anyway, Plack handlers have (undocumented!) 'server_ready' option to web
servers, containing callback (code reference).  It can be set via
parse_options method of Plack::Runner, for example.  It is used by
'plackup' to print

  $server: Accepting connections at $proto://$host:$port

in the (default) "development" mode.

> 
> Adapted and abridged from the Rainbows! web server test suite, the
> following config snippet is from the config file for the Rainbows! web
> server:
> ---------------- rainbows.conf.rb -----------------
> after_fork do |server, worker|
>   # test script will block while reading from the FIFO,
>   # so notify the script on the first worker we spawn
>   # by opening the FIFO
>   if worker.nr == 0
>     File.open("/path/to/fifo", "wb") { |fp| fp.syswrite "START" }
>   end
> end
> ---------------------------------------------------
> 
> And then in the test script:
> ----------- my-integration-test.sh ----------------
> set -e
> mkfifo /path/to/fifo
> # start the server
> rainbows --daemonize --config-file rainbows.conf.rb
> 
> # "cat /path/to/fifo" will block until the after_fork hook is called
> # in rainbows.conf.rb
> test xSTART = x"$(cat /path/to/fifo)"
> 
> # server is up, run the rest of the tests...
> ---------------------------------------------------

I wonder how portable is that technique...

It certainly could be done in gitweb.psgi; the question is if it is it
worth it...

-- 
Jakub Narebski
Poland